Attribute VB_Name = "CSA_Main"
Option Explicit
DefLng A-Z

Public filename As String

Public romdat() As Byte
Public romsize As Long

Public NESPAL(&HFF) As Long
Public NESPALL(&HFF) As Long
Public NESPALD(&HFF) As Long

Public BankReg() As Long
Public BankReg_last As Long
Public CoordBankReg(1) As Long

Public BankPtr(2) As Long

Public BaseSprLo As Long
Public BaseSprHi As Long
Public BaseFrameLo As Long
Public BaseFrameHi As Long
Public BaseCoordLo As Long
Public BaseCoordHi As Long

Public DataBank As Long
Public SprPtrBank As Long
Public FramePtrBank As Long
Public CoordPtrBank As Long

Public SprAddrLowBound As Long
Public SprAddrHighBound As Long
Public FrameAddrLowBound As Long
Public FrameAddrHighBound As Long
Public CoordAddrLowBound As Long
Public CoordAddrHighBound As Long

Public MaxSprite As Long

Public DataMovable As Long

Public Type DataSegsType
    Start As Long
    End As Long
    Free As Long
End Type

Public DataSegLast As Long
Public DataSegs() As DataSegsType

Public Type PtrSegsType
    loptr As Long
    hiptr As Long
    entries As Long
End Type

Public PtrSegLast As Long
Public PtrSegs() As PtrSegsType

Public CoordPointerAdd As Long
Public FramePointerAdd As Long
Public FrameTileNumofBase As Long
Public FramePageMethod As Long
Public CoordinateBankSelect As Long
Public CoordPairs As Long
Public DataParseSensitive As Long

'CoordPointerAdd : Correction to Coordinate data pointer. Used for MM2.
'FramePointerAdd : Correction to Frame data pointer. Used for MM5.
'FrameTileNumofBase : Base of value in frame data which tells number of tiles
'   the frame contains. (0 for 0-based or 1 for 1-based).
'   1-based: MM2
'   0-based: All others.
'FramePageMethod : Method of determining Frame Page.
'   0 : Determined by MSB bit 0 of Sprite Data. (All except Megaman 2)
'   1 : Determinde by Sprite ID. (Megaman 2)
'       Sprite ID = 00-7F : Frame Page = 0 (00-FF)
'       Sprite ID = 80-FF : Frame Page = 1 (100-1FF)
'CoordinateBankSelect : Specifies if the 2nd switchable bank of the MMC3 mapper
'   is changeable for use for coordinate data. The bank used is decided by the
'   1st byte of Frame data, MSB bit 0.
'CoordPairs : Option for if game utilizes pairs of coordinate data for left
'   and right facing directions. Some games uses pairs of data, other games
'   handle the X coordinate invertion on the fly.
'   0: MM2, MM5, ??
'   1: MM4, Darkwing Duck
'DataParseSensitive : Just a work-around option for Darkwing Duck for free space
'   to be calculated correcly. When 1, it stops reading Sprite ID's when one of
'   its containing Frame ID's has a bad pointer. Darkwing Duck has this in the
'   middle of the Sprite ID's. When 0, it will stop reading Sprite ID's when the
'   Sprite pointer itself is bad only.
'   0: Darkwing Duck
'   1: All others.
'   (Default value is 1)

Public ResetAll_Enabled As Boolean
Public ResetAreas As Long
Public ResetArea_Start() As Long
Public ResetArea_Size() As Long

Public BankPtrSelect As Long
'Public BankPtr As Long
Public Sprite As Byte
Public FramePage As Long
Public Frame As Long
Public FrameID As Long
Public CoordID As Long
Public CoordID2 As Long
Public AnimationFrames As Long
Public AnimationDelay As Long
Public FrameLastTile As Long
Public SelTile As Long
Public HoverTile As Long

Public AnimateFC As Long

Public SprAddr As clsNESAddr
Public FrameAddr As clsNESAddr
Public CoordAddr As clsNESAddr
Public Coord2Addr As clsNESAddr
Public TmpAddr As clsNESAddr

Public gPtrDataMove As clsPtrDataMove

Public FrameCoordClipboardSz As Long
Public FrameClipBoard() As Byte
Public CoordClipBoard() As Byte

Public SpriteFrameUsage(&HFF, &H1FF) As Boolean
Public FrameCoordUsage(&H1FF, &HFF) As Boolean
Public FrameCoordPairUsage(&H1FF, &HFF) As Boolean
Public CoordTileCount(&HFF) As Integer
Public UsageMap(&H7FFF) As Byte

Public MoveAllTiles As Byte

Public TileZPrio As Long

Public ViewZoom As Long
Public ViewX As Long
Public ViewY As Long
Public ViewMinX As Long
Public ViewMinY As Long
Public ViewMaxX As Long
Public ViewMaxY As Long
Public Animate As Byte
Public AnimSpeed As Byte
Public AnimRepeatA As Byte
Public CursorType As Long
Public ShowCursors As Byte
Public ShowGrid As Byte

Public DisableCoordInsDel As Byte

Public SprPal(&HF) As Byte
Public PatternMap(&HFFF) As Long

'Public Background_RGB As Long
Public BGCol_R As Long
Public BGCol_G As Long
Public BGCol_B As Long

Public PatClipboard(&HF) As Byte

Public grid_bm As bmbuffer
Public spr_bm As bmbuffer
Public main_bmi As BITMAPINFO

Public ANDtbl(7) As Long
Public InvANDtbl(7) As Long

Public Sub Main()
Dim a, b

ANDtbl(0) = &H80
ANDtbl(1) = &H40
ANDtbl(2) = &H20
ANDtbl(3) = &H10
ANDtbl(4) = &H8
ANDtbl(5) = &H4
ANDtbl(6) = &H2
ANDtbl(7) = &H1

InvANDtbl(0) = &H7F
InvANDtbl(1) = &HBF
InvANDtbl(2) = &HDF
InvANDtbl(3) = &HEF
InvANDtbl(4) = &HF7
InvANDtbl(5) = &HFB
InvANDtbl(6) = &HFD
InvANDtbl(7) = &HFE

LoadCfg "csa.cfg"

If GetCfg("warning") = 0 Then
    MsgBox "Note: Please make sure to backup your work before making any changes to it with this editor. Its very easy to end up with corrupted sprite data. It can happen to sprites anywhere in the game (in the same bank) as a result of changing something else. I do not take respnosbility for any consequences the use of this program may have on your project. This is a one-time warning notification."
    SetCfg "warning", 1
End If

ReloadNESPAL

'ChDir App.Path

'FileName = "megaman2.nes"
'GoTo debug_init

Dim openwnd As New clsDialog
filename = openwnd.ShowOpen(Form1.hWnd, "Select ROM", , "nes roms (*.nes)|*.nes|all files (*.*)|*.*", FILEMUSTEXIST Or LONGNAMES)
If Len(filename) = 0 Then End
filename = Left$(filename, Len(filename) - 1)

Open filename For Binary As #1
romsize = (LOF(1) - 1)
ReDim romdat(romsize)
Get #1, , romdat
Close #1

Support.Refresh_GameList
Support.Show
Support.SetFocus
End Sub

Public Sub Init2(supfile As String)
Dim a, b

'Mega Man 3 uses a bank arrangement where the sprite
'banks is not straight 16k banks, and can't be supported
'by the current system.
'To be supported.

'Mighty Final Fight uses a bankswitching scheme for sprites
'which changes the 2nd switchable bank of the MMC3.
'To be supported later.

SupInp.load supfile

SprAddrLowBound = (&H8000& + (SprPtrBank * &H4000))
SprAddrHighBound = (&HC000& + (SprPtrBank * &H4000)) - 1
FrameAddrLowBound = (&H8000& + (FramePtrBank * &H4000))
FrameAddrHighBound = (&HC000& + (FramePtrBank * &H4000)) - 1
CoordAddrLowBound = (&H8000& + (CoordPtrBank * &H4000))
CoordAddrHighBound = (&HC000& + (CoordPtrBank * &H4000)) - 1

MoveAllTiles = 0

TileZPrio = 0

AnimSpeed = 0
Form1.Timer1.Interval = 16
AnimRepeatA = 0
Animate = 0
ViewZoom = 4
Form1.RecalcViewXY

ShowCursors = 1
ShowGrid = 1

CursorType = 0

DisableCoordInsDel = 0

Set gPtrDataMove = New clsPtrDataMove

'a = &H8000& + (DataBank * &H4000) + BaseData
'gPtrDataMove.DataStart = a
'gPtrDataMove.DataEnd = a + BaseDataSz - 1

gPtrDataMove.RegardFreeSpace = True
FeedSegmentInfo

Init_Address_Classes

FrameCoordClipboardSz = -1

'Initialize RAW Buffers
CSA_Render.RAW_Init grid_bm, (8 * 32), (8 * 32)
CSA_Render.RAW_Init spr_bm, (8 * 32), (8 * 32)

'Create grid BM
For a = 0 To 31
For b = 0 To 31
CSA_Render.RAW_LineH grid_bm, (b * 8), (b * 8) + 7, (a * 8), &H41
CSA_Render.RAW_LineV grid_bm, (b * 8), (a * 8), (a * 8) + 7, &H41
Next b
Next a
CSA_Render.RAW_LineV grid_bm, 128, 0, 255, &H42
CSA_Render.RAW_LineH grid_bm, 0, 255, 128, &H42

BGCol_R = GetCfg("bgcolor_r")
BGCol_G = GetCfg("bgcolor_g")
BGCol_B = GetCfg("bgcolor_b")
'Background_RGB = GetCfg("bgcolor_r") Or (GetCfg("bgcolor_g") * 256) Or (GetCfg("bgcolor_b") * 65536)
'Background_RGB = RGB(&H60, &H0, &H60)   '60, 0, 60

CSA_Render.PB_Init Form1.WorkPic, main_bmi
Init_Bitmap_Palettes

Form1.Refresh_All
Form1.Show
Form1.SetFocus
End Sub

Public Sub FeedSegmentInfo()
'Pass information about data segments and pointer tables to global PtrDataMove class.
'Data segments : Areas of sprite data. Can be divided up through the bank, otherwise
'   there is always just one segment. The start pointer and size for each segment
'   is passed to the class.
'Pointer tables : Sprite data uses 3 pointer tables. (Sprite, Frame, Coordinate).
'   The size and offset information for each table is passed to the class.
'At the moment, all the data is temporarily stored in arrays generated by SupInp,
'then converted to a more basic format here and passed as arguments to the class
'sub/method "SetSegments".
Dim PtrSegArrTmp() As Long
Dim DataSegArrTmp() As Long
Dim a, b

If DataSegLast >= 0 Then
    b = 0
    ReDim DataSegArrTmp((DataSegLast * 2) + 1)
    For a = 0 To DataSegLast
        DataSegArrTmp(b) = DataSegs(a).Start
        DataSegArrTmp(b + 1) = DataSegs(a).End
        b = b + 2
    Next a
End If

If PtrSegLast >= 0 Then
    b = 0
    ReDim PtrSegArrTmp((PtrSegLast * 3) + 2)
    For a = 0 To PtrSegLast
        PtrSegArrTmp(b) = PtrSegs(a).loptr
        PtrSegArrTmp(b + 1) = PtrSegs(a).hiptr
        PtrSegArrTmp(b + 2) = PtrSegs(a).entries
        b = b + 3
    Next a
End If

If (DataSegLast >= 0) And (PtrSegLast >= 0) Then
    gPtrDataMove.SetSegments DataSegArrTmp, PtrSegArrTmp
End If
End Sub

Public Function Init_Address_Classes()
Dim tmpaddrref As clsNESAddr

Set SprAddr = New clsNESAddr
Set FrameAddr = New clsNESAddr
Set CoordAddr = New clsNESAddr
Set Coord2Addr = New clsNESAddr
Set TmpAddr = New clsNESAddr
Update_Address_Classes
SprAddr.InitSegsCDEF BankPtr(2)    'For games that use hard-wired bank.
FrameAddr.InitSegsCDEF BankPtr(2)  'For games that use hard-wired bank.
CoordAddr.InitSegsCDEF BankPtr(2)  'For games that use hard-wired bank.
Coord2Addr.InitSegsCDEF BankPtr(2) 'For games that use hard-wired bank.
TmpAddr.InitSegsCDEF BankPtr(2)    'For games that use hard-wired bank.

Set tmpaddrref = gPtrDataMove.GetNESAddrRef
tmpaddrref.InitSegsCDEF BankPtr(2)
Set tmpaddrref = gPtrDataMove.GetNESAddr2Ref
tmpaddrref.InitSegsCDEF BankPtr(2)
End Function

'BankPtr(0) changed.
Public Function Update_Address_Classes()
Dim tmpaddrref As clsNESAddr

Select Case CoordinateBankSelect
Case 0
    SprAddr.InitSegs89AB BankPtr(0)
    FrameAddr.InitSegs89AB BankPtr(0)
    CoordAddr.InitSegs89AB BankPtr(0)
    Coord2Addr.InitSegs89AB BankPtr(0)
    TmpAddr.InitSegs89AB BankPtr(0)

    Set tmpaddrref = gPtrDataMove.GetNESAddrRef
    tmpaddrref.InitSegs89AB BankPtr(0)
    Set tmpaddrref = gPtrDataMove.GetNESAddr2Ref
    tmpaddrref.InitSegs89AB BankPtr(0)
Case 1
    SprAddr.InitSegs89 BankPtr(0)
    FrameAddr.InitSegs89 BankPtr(0)
    CoordAddr.InitSegs89 BankPtr(0)
    Coord2Addr.InitSegs89 BankPtr(0)
    TmpAddr.InitSegs89 BankPtr(0)

    Set tmpaddrref = gPtrDataMove.GetNESAddrRef
    tmpaddrref.InitSegs89 BankPtr(0)
    Set tmpaddrref = gPtrDataMove.GetNESAddr2Ref
    tmpaddrref.InitSegs89 BankPtr(0)
End Select
End Function

Public Function Update_Address_Classes_CoordBank(bankselect)
Dim a
Dim tmpaddrref As clsNESAddr

a = CoordBankReg(bankselect)
SprAddr.InitSegsAB a
FrameAddr.InitSegsAB a
CoordAddr.InitSegsAB a
Coord2Addr.InitSegsAB a
TmpAddr.InitSegsAB a

Set tmpaddrref = gPtrDataMove.GetNESAddrRef
tmpaddrref.InitSegsAB a
Set tmpaddrref = gPtrDataMove.GetNESAddr2Ref
tmpaddrref.InitSegsAB a
End Function

Public Sub InitTmpNESAddr(ByRef nesaddrclass As clsNESAddr)
Set nesaddrclass = New clsNESAddr
nesaddrclass.InitSegs89AB BankPtr(0)
nesaddrclass.InitSegsCDEF BankPtr(2)
End Sub

'Set standard colors + standard sprite palette
'Onto all BITMAPINFO structs.
'Note: All BITMAPINFO structs are initialized on startup.
Public Function Init_Bitmap_Palettes()
Reload_Bitmap_Palettes

main_bmi.pal(0) = RGBmirr(RGB(BGCol_R, BGCol_G, BGCol_B))
main_bmi.pal(&H40) = RGB(0, 0, 0)
main_bmi.pal(&H41) = RGB(&H68, &H68, &H68)
main_bmi.pal(&H42) = RGB(&HC0, &HC0, &HC0)
main_bmi.pal(&H43) = RGB(&H0, &HFF, &H0)
main_bmi.pal(&H44) = RGB(&HFF, &H0, &HFF)
End Function

Public Function Reload_Bitmap_Palettes()
Dim a
For a = 1 To &HF
main_bmi.pal(a) = NESPAL(SprPal(a))
main_bmi.pal(a + &H80) = NESPALL(SprPal(a))
main_bmi.pal(a + &HC0) = NESPALD(SprPal(a))
Next a
End Function

Public Function Rd(addr As Long) As Byte
If (addr <= UBound(romdat)) Then
    Rd = romdat(addr)
End If
End Function

Public Sub Wr(addr As Long, v As Byte)
If (addr <= UBound(romdat)) Then
    romdat(addr) = v
'    If Form1.Visible Then
'        Form1.WriteList.AddItem (Hex(addr) + " = " + Hex(v))
'        Form1.WriteList.ListIndex = (Form1.WriteList.ListCount - 1)
'    End If
End If
End Sub

Public Sub ReloadNESPAL()
Dim PathBackup As String
Dim palfile As String
Dim a, hr, hg, hb
Dim br As Byte
Dim bg As Byte
Dim bb As Byte

PathBackup = CurDir()
ChDir App.Path
palfile = GetCfg("palfile")
Open palfile For Binary As #1
For a = 0 To &H3F
Get #1, , br
Get #1, , bg
Get #1, , bb
NESPAL(a) = RGB(bb, bg, br)
NESPALD(a) = RGB(Int(bb / 1.5), Int(bg / 1.5), Int(br / 1.5))
hr = VWidth(br + 80, 0, 255)
hg = VWidth(bg + 80, 0, 255)
hb = VWidth(bb + 80, 0, 255)
NESPALL(a) = RGB(hb, hg, hr)
Next a
Close #1
ChDir PathBackup
End Sub

Public Function Get_BankReg_Index(bank As Long) As Long
Dim a
For a = 0 To BankReg_last
If bank = BankReg(a) Then
    Get_BankReg_Index = a
    Exit Function
End If
Next a
Get_BankReg_Index = -1
End Function
