Attribute VB_Name = "CSA_Render"
Option Explicit
DefLng A-Z

Private Declare Sub ZeroMem Lib "kernel32" Alias "RtlZeroMemory" (pDest As Any, ByVal Bytes As Long)
Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, ByVal lpBI As Long, ByVal wUsage As Long) As Long

Public Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type
Public Type BITMAPINFO
  Header As BITMAPINFOHEADER
  pal(255) As Long
  bits() As Byte
End Type

Public Type bmbuffer
    SX As Long
    SY As Long
    data() As Byte
End Type

Public Sub RAW_ZeroBuffer(ByRef bmbu As bmbuffer)
ZeroMem bmbu.data(0), (bmbu.SX * bmbu.SY)
End Sub

Public Sub RAW_DrawSprTile(ByRef bmbu As bmbuffer, y, x, Tile, Attr, palbase)

Dim pixX, pixY, color, b0, b1
Dim paloffs, PT_Ptr
Dim rawbm_ptr, rawbm_nextYoffs
Dim FlipX_XOR, FlipY_XOR

paloffs = ((Attr And 3) * 4) + palbase
rawbm_nextYoffs = (bmbu.SX - 8)
rawbm_ptr = (((y + &H80) And &HFF) * bmbu.SX) + ((x + &H80) And &HFF)
PT_Ptr = Tile * &H10
If (Attr And &H80) Then
    FlipY_XOR = 7
Else
    FlipY_XOR = 0
End If
If (Attr And &H40) Then
    FlipX_XOR = 7
Else
    FlipX_XOR = 0
End If

For pixY = 0 To 7
    b0 = Rd(PatternMap(PT_Ptr + 0 + (pixY Xor FlipY_XOR)))
    b1 = Rd(PatternMap(PT_Ptr + 8 + (pixY Xor FlipY_XOR)))
    For pixX = 0 To 7
        color = _
        ((b0 And ANDtbl(pixX Xor FlipX_XOR)) <> 0 And 1) Or _
        ((b1 And ANDtbl(pixX Xor FlipX_XOR)) <> 0 And 1 * 2) Or paloffs
        If (rawbm_ptr >= (bmbu.SX * bmbu.SY)) Then Exit Sub
        If (color And 3) Then
        bmbu.data(rawbm_ptr) = color
        End If
        rawbm_ptr = rawbm_ptr + 1
    Next pixX
    rawbm_ptr = rawbm_ptr + rawbm_nextYoffs
Next pixY
End Sub

Public Function RenderPic(BMPB As PictureBox, ByRef bmix As BITMAPINFO) As Long
RenderPic = SetDIBits(BMPB.hdc, BMPB.Image.Handle, 0, BMPB.ScaleHeight, bmix.bits(0), VarPtr(bmix), 0)
BMPB.Refresh
End Function

Public Sub PB_Init(BMPB As PictureBox, ByRef bmix As BITMAPINFO)
Dim WidthOf As Long, HeightOf As Long
WidthOf = BMPB.ScaleWidth
HeightOf = BMPB.ScaleHeight
With bmix.Header
    .biSize = 40
    .biWidth = WidthOf
    .biHeight = -HeightOf
    .biPlanes = 1
    .biBitCount = 8
    .biSizeImage = 2 * (WidthOf - 1) * (HeightOf - 1)
    .biClrUsed = 256
End With
ReDim bmix.bits(bmix.Header.biSizeImage - 1)
End Sub

Public Sub PB_ReSizeInit(BMPB As PictureBox, ByRef bmix As BITMAPINFO)
Dim WidthOf, HeightOf
WidthOf = BMPB.ScaleWidth
HeightOf = BMPB.ScaleHeight
With bmix.Header
    .biWidth = WidthOf
    .biHeight = -HeightOf
    .biSizeImage = 2 * (WidthOf - 1) * (HeightOf - 1)
End With
ReDim bmix.bits(bmix.Header.biSizeImage - 1)
End Sub

Public Sub Reset_Bits(TilePB As PictureBox, ByRef bmix As BITMAPINFO)
ReDim bmix.bits(0)
ReDim bmix.bits(bmix.Header.biSizeImage - 1)
End Sub

Public Sub RAW_Init(bmbu As bmbuffer, h As Long, w As Long)
bmbu.SX = h
bmbu.SY = w
ReDim bmbu.data((h * w) - 1)
End Sub

Public Sub RAW_LineH(ByRef bmbu As bmbuffer, x1, x2, y, col)
C_LineH bmbu.SX, bmbu.data, (bmbu.SX * bmbu.SY), x1, x2, y, col
End Sub

Public Sub RAW_LineV(ByRef bmbu As bmbuffer, x, Y1, Y2, col)
C_LineV bmbu.SX, bmbu.data, (bmbu.SX * bmbu.SY), x, Y1, Y2, col
End Sub

Private Sub C_LineH(width, ByRef buffer() As Byte, bound, x1, x2, y, col)
Dim a, rowbytebase
rowbytebase = (y * width)
For a = x1 To x2
    If ((rowbytebase + a) < bound) And ((rowbytebase + a) >= 0) Then
        buffer(rowbytebase + a) = col
    End If
Next a
End Sub

Private Sub C_LineV(width, ByRef buffer() As Byte, bound, x, Y1, Y2, col)
Dim a
For a = Y1 To Y2
    If (((a * width) + x) < bound) And (((a * width) + x) >= 0) Then
        buffer((a * width) + x) = col
    End If
Next a
End Sub

Public Sub Blit1(ByRef rawbm1 As bmbuffer, ByRef DstPB As PictureBox, ByRef bmip As BITMAPINFO, zoom, baseX, baseY)
Dim tmpbuf As bmbuffer
RAW_Init tmpbuf, rawbm1.SY, rawbm1.SX
RAW_ZeroBuffer tmpbuf
Blit2 rawbm1, tmpbuf, DstPB, bmip, zoom, baseX, baseY
End Sub

'Blit two raw bitmaps together onto a BITMAPINFO bitmap.
'0 is mask color.
'Zoom, offset X and Y are definable.
'(the two bitmaps are assumed the same width.)
Public Sub Blit2(ByRef rawbm1 As bmbuffer, ByRef rawbm2 As bmbuffer, ByRef DstPB As PictureBox, ByRef bmip As BITMAPINFO, zoom, baseX, baseY)
Dim color
Dim pbheight, pbwidth
Dim bmibm_ptr, bmibm_nextptr, bmibm_endptr
Dim bmirow_bsz0, bmirow_bsz1, bmirow_bsz2, bmirow_bsz3
Dim bmirow_bsz10, bmirow_bsz11, bmirow_bsz12, bmirow_bsz13
Dim bmirow_bsz20, bmirow_bsz21, bmirow_bsz22, bmirow_bsz23
Dim rawbm_ptr, rawbm_nextptr, rawbm_endptr
Dim fillX

pbheight = (DstPB.ScaleHeight)
pbwidth = (DstPB.ScaleWidth)

bmibm_ptr = 0
bmibm_endptr = (pbwidth * pbheight)
rawbm_endptr = (rawbm1.SX * rawbm1.SY)

If (baseY < 0) Then
    rawbm_nextptr = 0
Else
    rawbm_nextptr = (baseY * rawbm1.SX)
End If

Select Case zoom
Case 1

    If (baseY < 0) Then
        bmibm_nextptr = (-baseY * pbwidth)
        While Not (bmibm_ptr = bmibm_nextptr)
            bmip.bits(bmibm_ptr) = 0
            bmibm_ptr = bmibm_ptr + 1
        Wend
    End If
    
    Do
    
    bmibm_nextptr = bmibm_ptr + pbwidth
    
    If (baseX < 0) Then
        rawbm_ptr = rawbm_nextptr
        fillX = baseX
        While (fillX < 0)
            bmip.bits(bmibm_ptr) = 0
            bmibm_ptr = bmibm_ptr + 1
            fillX = fillX + 1
        Wend
    Else
        rawbm_ptr = rawbm_nextptr + baseX
    End If
    
    rawbm_nextptr = rawbm_nextptr + rawbm1.SX

    'While Not (bmibm_ptr = bmibm_nextptr)
    While Not (rawbm_ptr = rawbm_nextptr)
    'If (rawbm_ptr = rawbm_nextptr) Then
    '    rawbm_ptr = rawbm_ptr - rawbm1.SX
    'End If

    color = rawbm2.data(rawbm_ptr)
    If Not (color) Then '(if =mask color)
        If (rawbm1.data(rawbm_ptr)) Then
            color = rawbm1.data(rawbm_ptr)
        End If
    End If
    
    bmip.bits(bmibm_ptr) = color
    
    bmibm_ptr = bmibm_ptr + 1

    rawbm_ptr = rawbm_ptr + 1
    Wend
    
    While Not (bmibm_ptr = bmibm_nextptr)
        bmip.bits(bmibm_ptr) = 0
        bmibm_ptr = bmibm_ptr + 1
    Wend
    
    Loop Until (rawbm_ptr >= rawbm_endptr)
    
    While Not (bmibm_ptr >= bmibm_endptr)
        bmip.bits(bmibm_ptr) = 0
        bmibm_ptr = bmibm_ptr + 1
    Wend
    
    'Loop Until (bmibm_ptr >= bmibm_endptr)

Case 2

    bmirow_bsz0 = pbwidth
    bmirow_bsz1 = pbwidth + 1
    
    Do
    
    bmibm_nextptr = bmibm_ptr + pbwidth
    
    rawbm_ptr = rawbm_nextptr + baseX
    
    rawbm_nextptr = rawbm_nextptr + rawbm1.SX

    While Not (bmibm_ptr >= bmibm_nextptr)
    'While Not (rawbm_ptr = rawbm_nextptr)
    If (rawbm_ptr = rawbm_nextptr) Then
        rawbm_ptr = rawbm_ptr - rawbm1.SX
    End If

    color = rawbm2.data(rawbm_ptr)
    If Not (color) Then '(if =mask color)
        If (rawbm1.data(rawbm_ptr)) Then
            color = rawbm1.data(rawbm_ptr)
        End If
    End If
    
    bmip.bits(bmibm_ptr) = color
    bmip.bits(bmibm_ptr + 1) = color
    bmip.bits(bmibm_ptr + bmirow_bsz0) = color
    bmip.bits(bmibm_ptr + bmirow_bsz1) = color

    bmibm_ptr = bmibm_ptr + 2

    rawbm_ptr = rawbm_ptr + 1
    Wend
    bmibm_ptr = bmibm_ptr + pbwidth
    
    'Loop Until (rawbm_ptr >= rawbm_endptr)
    
    Loop Until (bmibm_ptr >= bmibm_endptr)

Case 3

    bmirow_bsz0 = pbwidth + 0
    bmirow_bsz1 = pbwidth + 1
    bmirow_bsz2 = pbwidth + 2
    bmirow_bsz10 = (pbwidth * 2)
    bmirow_bsz11 = bmirow_bsz10 + 1
    bmirow_bsz12 = bmirow_bsz10 + 2
    
    Do
    
    bmibm_nextptr = bmibm_ptr + pbwidth
    
    rawbm_ptr = rawbm_nextptr + baseX
    
    rawbm_nextptr = rawbm_nextptr + rawbm1.SX

    While Not (bmibm_ptr >= bmibm_nextptr)
    'While Not (rawbm_ptr = rawbm_nextptr)
    If (rawbm_ptr = rawbm_nextptr) Then
        rawbm_ptr = rawbm_ptr - rawbm1.SX
    End If

    color = rawbm2.data(rawbm_ptr)
    If Not (color) Then '(if =mask color)
        If (rawbm1.data(rawbm_ptr)) Then
            color = rawbm1.data(rawbm_ptr)
        End If
    End If
    
    bmip.bits(bmibm_ptr) = color
    bmip.bits(bmibm_ptr + 1) = color
    bmip.bits(bmibm_ptr + 2) = color
    bmip.bits(bmibm_ptr + bmirow_bsz0) = color
    bmip.bits(bmibm_ptr + bmirow_bsz1) = color
    bmip.bits(bmibm_ptr + bmirow_bsz2) = color
    bmip.bits(bmibm_ptr + bmirow_bsz10) = color
    bmip.bits(bmibm_ptr + bmirow_bsz11) = color
    bmip.bits(bmibm_ptr + bmirow_bsz12) = color

    bmibm_ptr = bmibm_ptr + 3

    rawbm_ptr = rawbm_ptr + 1
    Wend
    bmibm_ptr = bmibm_ptr + bmirow_bsz10
    
    'Loop Until (rawbm_ptr >= rawbm_endptr)
    
    Loop Until (bmibm_ptr >= bmibm_endptr)


Case 4

    bmirow_bsz0 = pbwidth
    bmirow_bsz1 = pbwidth + 1
    bmirow_bsz2 = pbwidth + 2
    bmirow_bsz3 = pbwidth + 3
    bmirow_bsz10 = (pbwidth * 2)
    bmirow_bsz11 = bmirow_bsz10 + 1
    bmirow_bsz12 = bmirow_bsz10 + 2
    bmirow_bsz13 = bmirow_bsz10 + 3
    bmirow_bsz20 = (pbwidth * 3)
    bmirow_bsz21 = bmirow_bsz20 + 1
    bmirow_bsz22 = bmirow_bsz20 + 2
    bmirow_bsz23 = bmirow_bsz20 + 3

    Do
    
    bmibm_nextptr = bmibm_ptr + pbwidth
    
    rawbm_ptr = rawbm_nextptr + baseX
    
    rawbm_nextptr = rawbm_nextptr + rawbm1.SX

    While Not (bmibm_ptr >= bmibm_nextptr)
    'While Not (rawbm_ptr = rawbm_nextptr)
    If (rawbm_ptr = rawbm_nextptr) Then
        rawbm_ptr = rawbm_ptr - rawbm1.SX
    End If

    color = rawbm2.data(rawbm_ptr)
    If Not (color) Then '(if =mask color)
        If (rawbm1.data(rawbm_ptr)) Then
            color = rawbm1.data(rawbm_ptr)
        End If
    End If
    
    bmip.bits(bmibm_ptr) = color
    bmip.bits(bmibm_ptr + 1) = color
    bmip.bits(bmibm_ptr + 2) = color
    bmip.bits(bmibm_ptr + 3) = color
    bmip.bits(bmibm_ptr + bmirow_bsz0) = color
    bmip.bits(bmibm_ptr + bmirow_bsz1) = color
    bmip.bits(bmibm_ptr + bmirow_bsz2) = color
    bmip.bits(bmibm_ptr + bmirow_bsz3) = color
    bmip.bits(bmibm_ptr + bmirow_bsz10) = color
    bmip.bits(bmibm_ptr + bmirow_bsz11) = color
    bmip.bits(bmibm_ptr + bmirow_bsz12) = color
    bmip.bits(bmibm_ptr + bmirow_bsz13) = color
    bmip.bits(bmibm_ptr + bmirow_bsz20) = color
    bmip.bits(bmibm_ptr + bmirow_bsz21) = color
    bmip.bits(bmibm_ptr + bmirow_bsz22) = color
    bmip.bits(bmibm_ptr + bmirow_bsz23) = color

    bmibm_ptr = bmibm_ptr + 4

    rawbm_ptr = rawbm_ptr + 1
    Wend
    bmibm_ptr = bmibm_ptr + bmirow_bsz20
    
    'Loop Until (rawbm_ptr >= rawbm_endptr)
    
    Loop Until (bmibm_ptr >= bmibm_endptr)


End Select

End Sub
