VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsNESAddr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
DefLng A-Z

'NES Memory/ROM Address handler class
'With support for complex bankswitching.

Public lo As Long
Public hi As Long
Private seg_p(7) As Long

Public Sub InitSegs89(bankaddr As Long)
seg_p(0) = bankaddr
seg_p(1) = bankaddr + &H1000
End Sub

Public Sub InitSegsAB(bankaddr As Long)
seg_p(2) = bankaddr
seg_p(3) = bankaddr + &H1000
End Sub

Public Sub InitSegs89AB(bankaddr As Long)
seg_p(0) = bankaddr
seg_p(1) = bankaddr + &H1000
seg_p(2) = bankaddr + &H2000
seg_p(3) = bankaddr + &H3000
End Sub

Public Sub InitSegsCDEF(bankaddr As Long)
seg_p(4) = bankaddr
seg_p(5) = bankaddr + &H1000
seg_p(6) = bankaddr + &H2000
seg_p(7) = bankaddr + &H3000
End Sub

Public Property Let seg(Index As Long, data As Long)
seg_p(Index) = data
End Property

Public Property Get seg(Index As Long) As Long
seg = seg_p(Index)
End Property

Public Property Let mem(data As Long)
lo = (data And &HFF)
hi = (data And &HFF00&) / &H100
End Property

Public Property Get mem() As Long
mem = lo Or (hi * &H100)
End Property

Public Function rom() As Long
Dim a
a = Me.mem
If a >= &H8000& Then
    rom = (a And &HFFF) + seg((a And &H7000) / &H1000)
Else
    rom = 0
End If
End Function
