VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPtrDataMove"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
DefLng A-Z

'clsPtrDataMove

'Class for handling movement of data by insertion / deletion,
'and pointer correction.

'External:
'Rd(ptr) - ROM address read
'Wr(ptr, data) - ROM address write

'Dependencies:
'clsNESAddr

Private prPointer As Long
Private prIDPointer As Long

Private prPtrSeg_Count As Long
Private prPtrSeg_Lo() As Long
Private prPtrSeg_Hi() As Long
Private prPtrSeg_Entries() As Long

Private prDataSeg_Count As Long
Private prDataSeg_Start() As Long
Private prDataSeg_End() As Long
Private prDataSeg_Free() As Long

Private prRegardFreeSpace As Boolean

Private myNESAddr As clsNESAddr
Private myNESAddr2 As clsNESAddr

Public Function InsertB(value As Byte) As Long
Dim a
InsertB = InsertMove(1)
If (InsertB > 0) Then Exit Function
WrMem prPointer, value
End Function

Public Sub InsertA(values() As Byte, numbytes)
Dim a
a = InsertMove(numbytes)
'For Each a In values
    
'Next a
End Sub

Public Sub PadInsert(numbytes)
Dim a
a = InsertMove(numbytes)
End Sub

Public Sub DeleteB()
DeleteMove 1
End Sub

Public Sub Delete(numbytes)
DeleteMove numbytes
End Sub

'Public Sub SetDataSegs(startinp() As Long, endinp() As Long, numof)
'prDataSegs_start = startinp
'prDataSegs_end = endinp
'prDataSegs_numof = numof
'End Sub

Public Function GetNESAddrRef() As clsNESAddr
Set GetNESAddrRef = myNESAddr
End Function

Public Function GetNESAddr2Ref() As clsNESAddr
Set GetNESAddr2Ref = myNESAddr2
End Function

Public Property Let RegardFreeSpace(value As Boolean)
prRegardFreeSpace = value
End Property

Public Property Get RegardFreeSpace() As Boolean
RegardFreeSpace = prRegardFreeSpace
End Property

Public Property Let SegFreeSpace(Index As Long, value As Long)
If Index <= UBound(prDataSeg_Free) Then
    prDataSeg_Free(Index) = value
End If
End Property

Public Property Get SegFreeSpace(Index As Long) As Long
If Index <= UBound(prDataSeg_Free) Then
    SegFreeSpace = prDataSeg_Free(Index)
End If
End Property

Public Property Let Pointer(a)
prPointer = a
End Property

Public Property Get Pointer()
Pointer = prPointer
End Property

Public Property Let IDPointer(a)
prIDPointer = a
End Property

Public Property Get IDPointer()
IDPointer = prIDPointer
End Property

'Public Property Let DataStart(a)
'pDataStart = a
'End Property

'Public Property Get DataStart()
'DataStart = prDataStart
'End Property

Public Sub SetSegments(SrcDataSegArr() As Long, SrcPtrSegArr() As Long)
Dim a
a = 0
prDataSeg_Count = 0
While Not (a > UBound(SrcDataSegArr))
    ReDim Preserve prDataSeg_Start(prDataSeg_Count)
    ReDim Preserve prDataSeg_End(prDataSeg_Count)
    ReDim Preserve prDataSeg_Free(prDataSeg_Count)
    prDataSeg_Start(prDataSeg_Count) = SrcDataSegArr(a + 0)
    prDataSeg_End(prDataSeg_Count) = SrcDataSegArr(a + 1)
    a = a + 2
    prDataSeg_Count = prDataSeg_Count + 1
Wend

a = 0
prPtrSeg_Count = 0
While Not (a > UBound(SrcPtrSegArr))
    ReDim Preserve prPtrSeg_Lo(prPtrSeg_Count)
    ReDim Preserve prPtrSeg_Hi(prPtrSeg_Count)
    ReDim Preserve prPtrSeg_Entries(prPtrSeg_Count)
    prPtrSeg_Lo(prPtrSeg_Count) = SrcPtrSegArr(a + 0)
    prPtrSeg_Hi(prPtrSeg_Count) = SrcPtrSegArr(a + 1)
    prPtrSeg_Entries(prPtrSeg_Count) = SrcPtrSegArr(a + 2)
    a = a + 3
    prPtrSeg_Count = prPtrSeg_Count + 1
Wend
End Sub

'Public Property Let DataEnd(a)
'prDataEnd = a
'End Property

'Public Property Get DataEnd()
'DataEnd = prDataEnd
'End Property

Private Sub Class_Initialize()
Set myNESAddr = New clsNESAddr
Set myNESAddr2 = New clsNESAddr
prRegardFreeSpace = False
End Sub

'* Private Subs/Functions --------------------------------------------->

Private Function InsertMove(bytes) As Long
Dim a, b
InsertMove = 0
For b = 0 To (prDataSeg_Count - 1)
If (prPointer >= prDataSeg_Start(b)) And (prPointer <= prDataSeg_End(b)) Then
    If prRegardFreeSpace = True Then
        If bytes > prDataSeg_Free(b) Then
            InsertMove = 1 + b
            Exit Function
        End If
        prDataSeg_Free(b) = prDataSeg_Free(b) - bytes
    End If
    For a = 0 To ((prDataSeg_End(b) - prPointer) - bytes)
        WrMem (prDataSeg_End(b) - a), RdMem(prDataSeg_End(b) - a - bytes)
    Next a
    MovePointers bytes, b
End If
Next b
End Function

Private Sub DeleteMove(bytes)
Dim a, b
For b = 0 To (prDataSeg_Count - 1)
If (prPointer >= prDataSeg_Start(b)) And (prPointer <= prDataSeg_End(b)) Then
    For a = 0 To ((prDataSeg_End(b) - prPointer) - bytes)
        WrMem (prPointer + a), RdMem(prPointer + a + bytes)
    Next a
    MovePointers -bytes, b
    If prRegardFreeSpace = True Then
        prDataSeg_Free(b) = prDataSeg_Free(b) + bytes
    End If
End If
Next b
End Sub

Private Sub MovePointers(bytes, dataseg)
Dim a, b
'Select Case prPtrType
'Case 0
    'Low and High split
    For b = 0 To (prPtrSeg_Count - 1)
        For a = 0 To (prPtrSeg_Entries(b) - 1)
            myNESAddr.mem = prPtrSeg_Lo(b) + a
            myNESAddr2.lo = Rd(myNESAddr.rom)
            myNESAddr.mem = prPtrSeg_Hi(b) + a
            myNESAddr2.hi = Rd(myNESAddr.rom)
            If (myNESAddr2.mem >= prDataSeg_Start(dataseg)) And _
                (myNESAddr2.mem <= prDataSeg_End(dataseg)) And _
                (myNESAddr2.mem > prIDPointer) Then
                    myNESAddr2.mem = myNESAddr2.mem + bytes
                    Wr myNESAddr.rom, myNESAddr2.hi
                    myNESAddr.mem = prPtrSeg_Lo(b) + a
                    Wr myNESAddr.rom, myNESAddr2.lo
            End If
        Next a
    Next b
'End Select
End Sub

Private Sub WrMem(mema, data As Byte)
myNESAddr.mem = mema
Wr myNESAddr.rom, data
End Sub

Private Function RdMem(mema) As Byte
myNESAddr.mem = mema
RdMem = Rd(myNESAddr.rom)
End Function

' <---------------------------------------------------------------------
